procedure omsky1d(filein, fileout)

string	filein = "gtc14aob4_object_sum_wl_tlt[136:184,*]"	{prompt="Input filename"}
string	fileout= "gtc14aob4_object_sum_wl_tlt_1"		{prompt="Output Sky subtracted filename"}
string	method = "median"					{prompt="Sky extration method [median, percent]"}
real	percent= 20.0						{prompt="Percentile value for sky [1-50]"}

begin
	string	filin, filout, skycol, filetmp1, algor
	real	frac
	int	dsky

	filin = filein; filout = fileout; algor = method; frac = percent/100.0

        filetmp1 = "temp_file_tmp1";  imdelete (filetmp1, ver-, >& "dev$null")
	imdelete (filout, ver-, >& "dev$null")
	hselect (filin, "NAXIS1", expr+) | scan(dsky)

	if (algor == "percent") {
        imexpr("sort(a)", filetmp1, filin, verb-)
        skycol = "["//str(int(frac*dsky))//",*]"
        imcopy (filetmp1//skycol, filout, ver-)
	}

	if (algor == "median") {
        imexpr("median(a)", filetmp1, filin, verb-)
        imcopy (filetmp1, filout, ver-)
	}
	imdelete (filetmp1, ver-, >& "dev$null")

end
