procedure omskysub(filnam)

string  filnam = "gtc14a_mos1abc_wl_tlt"   {prompt="File Name"}
int 	skytype= 1			   {prompt="Sky type [1=same, 2=skyslits, pair]"}
string	skyslit= "1,10,30"		   {prompt="Sky slitlet numbers"}
string	method = "median"		   {prompt="Method of obtaining sky spectrum [median, percent, bg]"}

begin
	string filin, filesky, filetmp, bgslit, srange, stype, sec[999], filetmp2, filesnr
	string	sky1[999], sky2[999], sec1[999], sec2[999], comm1, comm2, comm3, fileobj
	string  filetmp3, skycol
        int     i1, nslits, ix1, ix2, islit, slitx, slity, slityx
	int	isk[999], nsky, l2, ln, dsky, skysubopt
	bool	continue

        filin = filnam; bgslit = skyslit
	fileobj = filin//"_obj"; imdelete (fileobj, ver-, >& "dev$null")
	filesky = filin//"_sky"; imdelete (filesky, ver-, >& "dev$null")
	filesnr = filin//"_snr"; imdelete (filesnr, ver-, >& "dev$null")
	filetmp = filin//"_bg_tmp";    imdelete (filetmp, ver-, >& "dev$null")
	filetmp2 = filin//"_bg_tmp2";  imdelete (filetmp2, ver-, >& "dev$null")
	filetmp3 = filin//"_bg_tmp3";  imexpr ("a*0", filetmp, filin, verb-)

        omslits (filin, verb-)
        nslits = omslits.nslitlets
        list = omslits.out

	skysubopt = skytype
	#skysubopt = 1 ===> subtract sky using "background" task

	if (skysubopt == 1) {
	#Use this option when there are atleast 1 slitlet looking only at sky
	continue=yes; nsky = 0
	ln = strlen(bgslit) 
	while (continue) {
        nsky = nsky + 1
	l2 = strstr(",",bgslit)
	if (l2 == 0) { isk[nsky] = int(bgslit); continue = no } else { 
	isk[nsky] = int(substr(bgslit, 1, l2-1)); bgslit = substr(bgslit, l2+1, ln) }
	#print(nsky, " ", isk[nsky])
	}   #end while
	}

        if (skysubopt <= 2) {
	dsky = 10  #; dspe=20
	if (skysubopt == 1) {dsky = ix2-ix1+1}
        i1 = 0
        for (i = 1; i <= nslits; i = i + 1) {
        i1 = fscan(list, islit, ix1, ix2, slitx, slity, slityx, stype)
        #sec[i] = "["//str(ix1)//":"//str(ix2)//"]"
        sec[i] = "["//str(ix1)//":"//str(ix2)//",*]"
        #rng[i] = str(ix1)//":"//str(ix2)
        sky1[i] = str(ix1)//":"//str(ix1+dsky-1)
        sky2[i] = str(ix2-dsky+1)//":"//str(ix2)
	}

        if (skysubopt == 1) { srange = sky1[isk[1]]
	#if (i > 1) { for (i = 2; i <= nsky; i = i + 1) { srange = srange//","//sky1[isk[i]] } }
	for (i = 2; i <= nsky; i = i + 1) { srange = srange//","//sky1[isk[i]] } 
	} 
	if (skysubopt == 2) {srange = sky1[1]//","//sky2[1]
	for (i = 2; i <= nslits; i = i + 1) {srange = srange//","//sky1[i]//","//sky2[i]}
	}

	print ("Sky Section = ", srange)

	#background (filin, filetmp, axis=1, int-, sample=srange, naverage=dsky,
	#function="chebyshev", order=3, low_reject=0., high_reject=0., niterate=1,
	#grow=0., graphics="stdgraph", cursor="")

	#fit1d (filin, filetmp, "difference", axis=1, int-, sample=srange, naverage=1,
	fit1d (filin, filetmp, "fit", axis=1, int-, sample=srange, naverage=1,
        function="chebyshev", order=3, low_reject=0., high_reject=0., niterate=1,
        grow=0., graphics="stdgraph", cursor="")

	#background (filin, filetmp, axis=1, int-, sample=srange, naverage=1,
	#function="chebyshev", order=3, low_reject=0., high_reject=0., niterate=1,
	#grow=0., graphics="stdgraph", cursor="")
	##print(srange)

	}

	#if (skysubopt == 2) {
	#Use this option when each slitlet is at least "2*dsky+dspe" wide and the object
	#is centered in each slitlet occupying not more than "dspe" pixels
	#dsky = 10  #; dspe=20
        #i1 = 0
        #for (i = 1; i <= nslits; i = i + 1) {
        #i1 = fscan(list, islit, ix1, ix2, slitx, slity, slityx, stype)
        #sec[i] = "["//str(ix1)//":"//str(ix2)//",*]"
        #sky1[i] = str(ix1)//":"//str(ix1+dsky-1)
        #sky2[i] = str(ix2-dsky+1)//":"//str(ix2)
	#if (i==1){srange = sky1[1]//","//sky2[1]} else {srange = srange//","//sky1[i]//","//sky2[i]}
        #}
	#print ("Sky Section = ", srange)
	#}

	if (skysubopt == 3) {
	#Use this option when each slitlet is at least "2*dsky+dspe" wide and the object
	#is centered in each slitlet occupying not more than "dspe" pixels
	imexpr ("a*0", filetmp2, filin, verb-)
	imexpr ("a*0", filesnr, filin, verb-)
	dsky = 10  #; dspe=20
        i1 = 0
        for (i = 1; i <= nslits; i = i + 1) {
        i1 = fscan(list, islit, ix1, ix2, slitx, slity, slityx, stype)
	#dsky = ix2-ix1+1
        sec[i] = "["//str(ix1)//":"//str(ix2)//",*]"
        sec1[i] = "["//str(ix1)//":"//str(ix1+dsky-1)//",*]"
        sec2[i] = "["//str(ix2-dsky+1)//":"//str(ix2)//",*]"
	#comm1 = "a/((median(b)+median(c))/2.0)-1.0"
	comm2 = "a - (median(b)+median(c))/2.0"
	comm3 = "b/sqrt(a)"
	print("Analyzing slitlet no ", i, " Section = ", sec[i], " Skywidth = ", dsky)
	#imexpr(comm1, filetmp//sec[i], filin//sec[i], filin//sec1[i], filin//sec2[i], verb-)
	imexpr(comm2, filetmp//sec[i], filin//sec[i], filin//sec1[i], filin//sec2[i], verb-)
	imexpr(comm3, filetmp2//sec[i], filin//sec[i], filetmp//sec[i], verb-)
	imcopy (filetmp2//sec[i], filesnr//sec[i], ver-) 
        }
	}

	if (skysubopt == 4) {
	#Use this option when each slitlet is at least "2*dsky+dspe" wide and the object
	#is centered in each slitlet occupying not more than "dspe" pixels
	imexpr ("a*0", filetmp2, filin, verb-)
	#imexpr ("a*0", filetmp3, filin, verb-)
	imexpr ("a*0", filesnr, filin, verb-)
	dsky = 10  #; dspe=20
        i1 = 0
        for (i = 1; i <= nslits; i = i + 1) {
        i1 = fscan(list, islit, ix1, ix2, slitx, slity, slityx, stype)
	dsky = ix2-ix1+1
        sec[i] = "["//str(ix1)//":"//str(ix2)//",*]"
        #sec1[i] = "["//str(ix1)//":"//str(ix1+dsky-1)//",*]"
        #sec2[i] = "["//str(ix2-dsky+1)//":"//str(ix2)//",*]"
	comm1 = "sort(a)"
	imdelete (filetmp3, ver-, >& "dev$null");
	#imexpr("sort(a)", filetmp3//sec[i], filin//sec[i], verb-)
	imexpr("sort(a)", filetmp3, filin//sec[i], verb-)
        #skycol = "["//str(int(0.20*dsky))//":"//str(int(0.20*dsky))//",*]"
        skycol = "["//str(int(0.20*dsky))//",*]"
	if (i == 1) {splot (filetmp3//skycol)}
	imexpr("a-b", filetmp//sec[i], filin//sec[i], filetmp3//skycol, verb-)
	comm3 = "b/sqrt(a)"
	print("Analyzing slitlet no ", i, " Section = ", sec[i], " Skycol = ", skycol)
	imexpr(comm3, filetmp2//sec[i], filin//sec[i], filetmp//sec[i], verb-)
	imcopy (filetmp2//sec[i], filesnr//sec[i], ver-) 
        }
	}

        i1 = 0
	imcopy (filin, fileobj, ver-)
        for (i = 1; i <= nslits; i = i + 1) { imcopy (filetmp//sec[i], fileobj//sec[i], ver-) }
	imexpr("a-b", filesky, filin, fileobj, verb-)
	imdelete (filetmp, ver-, >& "dev$null");
	imdelete (filetmp2, ver-, >& "dev$null");
	imdelete (filetmp3, ver-, >& "dev$null");

	print("Sky subtrated 2D spectrum is = ",fileobj)
	print("Sky spectrum= ", filesky, " and SNR spectrum= ", filesnr, " are also stored.")

end
