procedure omskysub(filnam)

string  filnam = "gtc14aob4_object_sum_wl_tlt"   {prompt="File Name"}
string	skytype= "same"			   {prompt="Sky type [same, pair, skyslits, bg]"}
string	method = "median"		   {prompt="Method of obtaining sky spectrum [median, percent]"}
real    percent= 20.0                      {prompt="Percentile value for sky [1-50]"}
bool	normali= no		   	   {prompt="Normalize the sky spectrum before subtration?"}
string	pairlis= "pair.sky"		   {prompt="Object-Sky pair list"}
string	skyslit= "1,10,30"		   {prompt="Sky slitlet numbers"}
string	skyrang= ""		   	   {prompt="Sky range in pixels 240:260,300:310,1500:1520"}

begin
	string filin, filesky, filetmp, srange, stype, sec[999], filetmp2, filesnr
	string	sky1[999], sky2[999], sec1[999], sec2[999], comm1, comm2, comm3, fileobj
	string  skyopt, algor, filesky1d, filesky2d, slittype[999], pairfil, range
	real	pcent, exptime, tottime
        int     i, i1, nslits, ix1, ix2, islit, slitx, slity, slityx, i2, ncomb
	int	isk[999], nsky, l2, ln, dsky, skysubopt, nrej, irej, isky, npair
	bool	continue, norm, fitslit[999]
	struct	slitreject, bgslit

        filin = filnam; bgslit = skyslit; norm = normali; pcent = percent; range = skyrang
	skyopt = strlwr(substr(skytype, 1, 2)); algor = strlwr(substr(method, 1, 1))
	pairfil = pairlis
	#print(range)

	if (skyopt== "sa"){skyopt = "same"} 
	if (skyopt== "sk"){skyopt = "skyslits"}
	if (skyopt== "pa"){skyopt = "pair"}
	if (skyopt== "ba" || skyopt== "bg"){skyopt = "background"; algor = "background"}
	#if (skyopt !=  "same") {print("***Warning*** Sky option=",skyopt, " is not yet implemeted"); goto goexit}

	if (algor == "m"){algor = "median"}
	#if (algor == "b"){algor = "background"}
	if (algor == "p"){algor = "percent"}
	if (algor == "background" && skyopt != "background") {algor = "median"}
	print(skyopt, " ", algor)

	ncomb = 1
        hselect (filin, "EXPTIME NCOMBINE", expr+) | scan (exptime, ncomb)
	tottime = exptime*real(ncomb)
	#print(exptime, " ",ncomb, " ", tottime)
	#print(skyopt, " ", algor)
	#goto goexit

	fileobj = filin//"_obj"; imdelete (fileobj, ver-, >& "dev$null")
	filesky = filin//"_sky"; imdelete (filesky, ver-, >& "dev$null")
	filesnr = filin//"_snr"; imdelete (filesnr, ver-, >& "dev$null")
	filetmp = filin//"_bg_tmp"   ;    imdelete (filetmp, ver-, >& "dev$null")
	filetmp2 = filin//"_bg_tmp2" ;  imdelete (filetmp2, ver-, >& "dev$null")
	#filetmp3 = filin//"_bg_tmp3";  
	imexpr ("a*0", filetmp, filin, verb-)
	imexpr ("a*0", filetmp2, filin, verb-)

	#imcopy (filin, fileobj, ver-)
	#imcopy (filin, filesky, ver-)
	imexpr ("a*0", fileobj, filin, verb-)
	imexpr ("a*0", filesky, filin, verb-)
	imexpr ("a*0", filesnr, filin, verb-)

	#goto goexit

        omslits (filin, verb-)
        nslits = omslits.nslitlets
        list = omslits.out

        i1 = 0
        for (i = 1; i <= nslits; i = i + 1) {
        i1 = fscan(list, islit, ix1, ix2, slitx, slity, slityx, stype)
	dsky = ix2-ix1+1
        sec[i] = "["//str(ix1)//":"//str(ix2)//",*]"
        sky1[i] = str(ix1)//":"//str(ix1+dsky-1)
        sky2[i] = str(ix2-dsky+1)//":"//str(ix2)
	slittype[i] = stype
        fitslit[i] = yes
	}

        #hselect (filin, "SLITREJ", expr+) | scan (i1, i2)
        hselect (filin, "SLITREJ", expr+) | scan (slitreject)
	if (slitreject != "") {print(" reject ", slitreject)}
        files(slitreject) | wc | scan(nrej)
        for (i = 1; i <= nrej; i = i + 1) {
        files(slitrej) | fields (fields=1, lines=i) | scan(irej)
        fitslit[irej] = no
        print("Slit no ", i, " for rejection = ", irej)
        }

	if (skyopt == "same") {
        for (i = 1; i <= nslits; i = i + 1) {
        #for (i = 1; i <= 1; i = i + 1) {
	if (slittype[i] != "circular" && fitslit[i]) {
	#imdelete (filetmp, ver-, >& "dev$null"); imdelete (filetmp2, ver-, >& "dev$null")
	#imexpr ("a*0", filetmp, filin, verb-)
	filesky1d = filin//"_"//str(i)//"_sky1d"; imdelete (filesky1d, ver-, >& "dev$null");
	filesky2d = filin//"_"//str(i)//"_sky2d"; imdelete (filesky2d, ver-, >& "dev$null");
        #print("Analyzing slitlet no ", i, " Section = ", sec[i], " Skywidth = ", dsky)
        print("Analyzing slitlet no ", i, " Section = ", sec[i])
	omsky1d(filin//sec[i], filesky1d, method=algor, percent=pcent) 
	if (norm) {
	  omnormalize(filin//sec[i], filesky1d, filesky2d, normtyp = "flux", shiftw+, verb-)
		} else {ommake2d(filin//sec[i], filesky1d, filesky2d)}
        imexpr("a-b", filetmp//sec[i], filin//sec[i], filesky2d, verb-)
        imcopy (filetmp//sec[i], fileobj//sec[i], ver-)
        imexpr("b/sqrt(a)", filetmp2//sec[i], filin//sec[i], fileobj//sec[i], verb-)
        imcopy (filetmp2//sec[i], filesnr//sec[i], ver-)
        imcopy (filesky2d, filesky//sec[i], ver-)
	imdelete (filesky1d, ver-, >& "dev$null") 
	imdelete (filesky2d, ver-, >& "dev$null")
	}
	}
	}

	if (skyopt == "pair") {
	fields (pairfil, fields="1,2") | wc | scan(npair)
        for (k = 1; k <= npair; k = k + 1) {
	#fields (pairfil, fields="1,2") | fields (fields="1,2", line=k) 
	fields (pairfil, fields="1,2") | fields (fields="1,2", line=k) | scan(i, isky)
        print("Subtrating ",algor," sky from slitlet ", isky, "=",sec[isky]," for slitlet ", i, "=",sec[i])
	filesky1d = filin//"_"//str(i)//"_sky1d"; imdelete (filesky1d, ver-, >& "dev$null");
	omsky1d(filin//sec[isky], filesky1d, method=algor, percent=pcent) 
	filesky2d = filin//"_"//str(i)//"_sky2d"; imdelete (filesky2d, ver-, >& "dev$null");
        if (norm) {
          omnormalize(filin//sec[i], filesky1d, filesky2d, normtyp = "flux", shiftw+, verb-)
                } else {ommake2d(filin//sec[i], filesky1d, filesky2d)}
        imexpr("a-b", filetmp//sec[i], filin//sec[i], filesky2d, verb-)
        imcopy (filetmp//sec[i], fileobj//sec[i], ver-)
        imexpr("b/sqrt(a)", filetmp2//sec[i], filin//sec[i], fileobj//sec[i], verb-)
        imcopy (filetmp2//sec[i], filesnr//sec[i], ver-)
        imcopy (filesky2d, filesky//sec[i], ver-)
        imdelete (filesky1d, ver-, >& "dev$null")
        imdelete (filesky2d, ver-, >& "dev$null")
	}
	}

	if (skyopt == "skyslits") {
	##print(bgslit)
	delete ("temp_sky.lis", ver-, >& "dev$null")
        files(bgslit) | wc | scan(nsky)
        for (k = 1; k <= nsky; k = k + 1) {
        files(bgslit) | fields (fields=1, lines=k) | scan(isky)
	isk[k] = isky
	if (algor == "median") {
        filesky1d = filin//"_"//str(isky)//"_sky1d"; imdelete (filesky1d, ver-, >& "dev$null");
        omsky1d(filin//sec[isky], filesky1d, method=algor, percent=pcent)
	print(filesky1d, >> "temp_sky.lis")
	#omskysub skytype=skyslits skyslit="2,6,14,19,27"
	}
	}
	if (algor == "median") {
        filesky1d = filin//"_av_sky1d"; imdelete (filesky1d, ver-, >& "dev$null");
	imcomb ("@temp_sky.lis", filesky1d, scale="median", comb="median")
	imdelete ("@temp_sky.lis", ver-, >& "dev$null")
        for (i = 1; i <= nslits; i = i + 1) { 
	if (slittype[i] != "circular" && fitslit[i]) {
        print("Analyzing slitlet no ", i, " Section = ", sec[i])
	filesky2d = filin//"_"//str(i)//"_sky2d"; imdelete (filesky2d, ver-, >& "dev$null");
        if (norm) {
          omnormalize(filin//sec[i], filesky1d, filesky2d, normtyp = "flux", shiftw+, verb-)
                } else {ommake2d(filin//sec[i], filesky1d, filesky2d)}
        imexpr("a-b", filetmp//sec[i], filin//sec[i], filesky2d, verb-)
        imcopy (filetmp//sec[i], fileobj//sec[i], ver-)
        imexpr("b/sqrt(a)", filetmp2//sec[i], filin//sec[i], fileobj//sec[i], verb-)
        imcopy (filetmp2//sec[i], filesnr//sec[i], ver-)
        imcopy (filesky2d, filesky//sec[i], ver-)
        #imdelete (filesky1d, ver-, >& "dev$null")
        imdelete (filesky2d, ver-, >& "dev$null")
	}  #median
	}  #nslits
	}  #slittype 
	}  #skyopt

	if (skyopt == "background") {
	#if (algor == "background") {
	#goto goexit

	imdelete (filetmp, ver-, >& "dev$null")
	#print(range)
	if (range == "") {
	print("Please give a range e.g. 200:250,1950:2000 ")
	scan(srange)
	#srange = sky1[isk[1]]
        #for (i = 2; i <= nsky; i = i + 1) { srange = srange//","//sky1[isk[i]] }
	} else {srange = range}
	#print(srange)
        fit1d (filin, filetmp, "difference", axis=1, int-, sample=srange, naverage=1,
        function="spline3", order=1, low_reject=0., high_reject=0., niterate=1,
        #function="legendre", order=5, low_reject=0., high_reject=0., niterate=1,
        #function="chebyshev", order=4, low_reject=0., high_reject=0., niterate=1,
        grow=0., graphics="stdgraph", cursor="")
        #imdelete (filetmp, ver-, >& "dev$null"); imdelete (filetmp2, ver-, >& "dev$null")
        #filesky1d[i] = filin//"_"//str(i)//"_sky1d"; imdelete (filesky1d[i], ver-, >& "dev$null");
        #}

        for (i = 1; i <= nslits; i = i + 1) { 
	if (slittype[i] != "circular" && fitslit[i]) {
	imdelete (filetmp2, ver-, >& "dev$null")
	filesky2d = filin//"_"//str(i)//"_sky2d"; imdelete (filesky2d, ver-, >& "dev$null");
        imcopy (filetmp//sec[i], fileobj//sec[i], ver-)
        imexpr("(a > 0.0 && b > 0.0) ? b*sqrt(c)/sqrt(a) : 0.0", filetmp2, filin//sec[i], fileobj//sec[i], ncomb, verb-)
        #imexpr("b/sqrt(a)", filetmp2, filin//sec[i], fileobj//sec[i], verb-)
        imcopy (filetmp2, filesnr//sec[i], ver-)
        imexpr("a-b", filesky2d, filin//sec[i], fileobj//sec[i], verb-)
        imcopy (filesky2d, filesky//sec[i], ver-)
	imdelete (filetmp2, ver-, >& "dev$null")
	imdelete (filesky2d, ver-, >& "dev$null")
	# "(a > 0.0 && b > 0.0) ? b*sqrt(exptime)/sqrt(a) : 0.0"
	}  #nslits
	}  #slittype
	#}
	#imdelete (filetmp, ver-, >& "dev$null")

	}

	print("Sky subtrated 2D spectrum is = ",fileobj)
	print("Sky spectrum= ", filesky, " and SNR spectrum= ", filesnr, " are also stored.")

	imdelete (filetmp, ver-, >& "dev$null");
	imdelete (filetmp2, ver-, >& "dev$null");

goexit:
	#imdelete (filesky1d, ver-, >& "dev$null") 
	#imdelete (filesky2d, ver-, >& "dev$null")
	print("")

end
