procedure omstart(datadir)

string	datadir   = "GTC4-14AMEX/OB0001a1/object"	{prompt="Data directory"}
string	filein    = "all"				{prompt="File Name"}
bool	mosaic    = no					{prompt="Mosaic the 2 CCDs (no==>list only)"}
bool	verify    = no					{prompt="Verify each file before mosaic?"}
string	biasim    = "" 					{prompt="Bias image [empty means no Sub Bias]"}
#bool	fixpix    = no					{prompt="Fix bad pixels?"}
#string  mask1     = "DEFAULT"                           {prompt="Bad pixel image for CCD1"}
#string  mask2     = "DEFAULT"                           {prompt="Bad pixel image for CCD2"}

begin
	string	ddir, filin, filnam, filout, fildir, headlist, filbias, filanal
	string 	ommosaic, grism, tmpfil1, tmpfil2, tmpfil3, comment, obssem
	int	i, k, nfil, i1, i2, i3, xbin, ybin, i4, nanal    #obno
	bool	joinccd, interactive, ans 
	#bool	badmask
	#maskim1 = mask1; maskim2 = mask2
	#badmask = fixpix

	ddir = datadir; filin = filein; filbias = biasim
	joinccd = mosaic; interactive = verify #; headlist = headpar
	headlist = "$I TITLE NAXIS1 NAXIS2 GRISM FILTER1 FILTER2 FILTER3 EXPTIME CCDSUM SLITW"
	comment = "Output stored as "
	if (filbias == ""){filbias="null_bias"; imdelete (filbias, ver-, >& "dev$null")}
        if (filbias != "null_bias"){comment = "Bias subtracted output stored as "}

	i3 = strlen (ddir)
	i2 = strldx ("/", ddir)
	fildir = substr(ddir, i2+1, i3)

	i4 = stridx ("-", ddir)
	obssem = substr(ddir, i4+1, i4+3)
	obssem = strlwr(obssem)
	i4 = strstr ("OB", ddir)
	#obno = int(substr(ddir, i4+2, i2-1))
	#fildir = "gtc"//obssem//"ob"//str(obno)//"_"//fildir
	#obno = substr(ddir, i4+3, i2-1)
	fildir = "gtc"//obssem//"ob"//substr(ddir, i4+3, i2-1)//"_"//fildir
	#print (fildir)

	if (filin == "all") {
		print("Analyzing the following files")

	tmpfil1 = "lscommand"
	tmpfil2 = "datadir.lis"
	tmpfil3 = "omstart.log"
	delete (tmpfil1, ver-, >& "dev$null")
	delete (tmpfil2, ver-, >& "dev$null")
	print ("ls ",ddir, > tmpfil1)
	#cl < "lscommand", > "datadir.lis"
	type (tmpfil1) | cl (,> tmpfil2)
	wc (tmpfil2) | scan (nfil)

	for (i = 1; i <= nfil; i = i + 1) {
	#for (i = 1; i <= 2; i = i + 1) {
	fields (tmpfil2, 1, lines=i) | scan (filnam)
	i1 = stridx ("-", filnam)
	i2 = strldx (".", filnam)
	filnam = substr(filnam, 1, i2-1)
	filout = substr(filnam, i1-3, i1-1)
	filout = fildir//"_"//filout
	#if (atype == "list") { hselect(ddir//"/"//filnam//"[1]", headlist, expr+) } 
	#if (atype == "mosaic") {
	if (joinccd) {
	ans = yes
	if (interactive) {
	hselect(ddir//"/"//filnam//"[1]", "$I OBSMODE NAXIS1 NAXIS2 GRISM FILTER1 FILTER2 FILTER3 EXPTIME CCDSUM", expr+) 
	print("Want to mosaic ", filnam, "?")
	scan(ans)
	}
	if (ans) {
	hselect(ddir//"/"//filnam//"[1]", headlist, expr+)
        hselect (ddir//"/"//filnam//"[1]", "CCDSUM GRISM", expr+) | fields (fields="1-2") | scan (xbin, ybin, grism)
        ommosaic = "mosaic_"//str(xbin)//"x"//str(ybin)//"_v2 "//ddir//"/"//filnam
	#if (badmask) {ommosaic = ommosaic//" mask1 = "//maskim1//" mask2 = "//maskim2}
        print ("Running ", ommosaic)
	print (comment, filout)
        print (ommosaic) | cl >> "omstart.lis"
	if (filbias == "null_bias" && i == 1){imarith ("OsirisMosaic", "*", 0.0, filbias, ver-)}
	imdelete (filout, ver-, >& "dev$null")
	imarith ("OsirisMosaic", "-", filbias, filout, ver-)
        #imrename ("OsirisMosaic", filout, verb+)
        hedit (filout, "BIASSUB", filbias, add+, ver-, show-)
	} } else { hselect(ddir//"/"//filnam//"[1]", headlist, expr+) } 
	}    #next file
	} else {
	#if (atype == "list") {hselect(ddir//"/"//filin//"[1]", headlist, expr+)} 
        #if (atype == "mosaic") {

	#filanal = ddir//"/"//filin
        #files(filanal) | wc | scan(nanal)
        #for (k = 1; k <= nanal; k = k + 1) {
        #files(filanal) | fields (fields=1, lines=k) | scan(filin)
	#i2 = strldx ("/", filin)
	#i4 = strldx (".", filin)
	#if (i4 == 0){ i4= strlen (filin)} else {i4 = i4 - 1}
	#filin = substr(filin, i2+1, i4)
	#print(k, filin)

	if (joinccd) {
	#hselect(ddir//"/"//filin//"[1]", "$I OBSMODE NAXIS1 NAXIS2 GRISM FILTER1 FILTER2 FILTER3 EXPTIME CCDSUM", expr+) 
	#hselect(ddir//"/"//filnam//"[1]", headlist, expr+)
	hselect(ddir//"/"//filin//"[1]", headlist, expr+)
        hselect (ddir//"/"//filin//"[1]", "CCDSUM GRISM", expr+) | fields (fields="1-2") | scan (xbin, ybin, grism)
	ommosaic = "mosaic_"//str(xbin)//"x"//str(ybin)//"_v2 "//ddir//"/"//filin
	#if (badmask) {ommosaic = ommosaic//" mask1 = "//maskim1//" mask2 = "//maskim2}
	i1 = stridx ("-", filin)
	filout = substr(filin, i1-3, i1-1)
	filout = fildir//"_"//filout
	print ("Running ", ommosaic)
	print (comment, filout)
	print (ommosaic) | cl (, >> "omstart.log")
	if (filbias == "null_bias"){imarith ("OsirisMosaic", "*", 0.0, filbias, ver-)}
	imdelete (filout, ver-, >& "dev$null")
	imarith ("OsirisMosaic", "-", filbias, filout, ver-)
	#imrename ("OsirisMosaic", filout, verb+)
        hedit (filout, "BIASSUB", filbias, add+, ver-, show-)
	} else {hselect(ddir//"/"//filin//"[1]", headlist, expr+)}
        #}
	}
	delete (tmpfil1, ver-, >& "dev$null")
	delete (tmpfil2, ver-, >& "dev$null")
	imdelete ("OsirisMosaic", ver-, >& "dev$null")
	imdelete ("null_bias", ver-, >& "dev$null")

end
