procedure om_x_curve(filarc)

string  filarc  = "gtc12bob001_arcs" {prompt="File Name"}
real    lambda 	= 4046.   	     {prompt="Y position of the line at x=1040 or lambda"}

begin	
	string	filin, grism, id, longidlist, clines, stype, linefitlog
        real    slitx, slity, slityx, slito, ylin, cons, wlam
        int     i1, nslits, ix1, ix2, islit, i, npix, wlamx, nlin

	filin = filarc; wlamx = int(lambda)
	linefitlog = filarc//"_"//str(wlamx)//".dat"

        if (filin != "") {hselect (filin, "GRISM NAXIS2", expr+) | scan (grism, npix)}
	if (wlamx > npix) {
        longidlist = "gtcinputs$idarco"//grism//".txt"
        fields (longidlist, fields="2", lines=7) | scan (nlin)
        clines = "8-"//str(7+nlin)
        delete ("templist", ver-, >& "dev$null")
        fields (longidlist, fields="1,3,7", lines=clines) | grep (str(wlamx)) | scan(cons, wlam, id)
	} else {cons = wlamx}

        omslits (filin, verb-)
        nslits = omslits.nslitlets
        list = omslits.out

        delete (linefitlog, ver-, >& "dev$null")
        i1 = 0
        for (i = 1; i <= nslits; i = i + 1) {
        i1 = fscan(list, islit, ix1, ix2, slitx, slity, slityx, stype, slito)
	print(islit, ix1, ix2, slitx, slity, slityx, stype, " ",slito)
	ylin = cons + (slityx - slity) 
        #omlinefit (filin, xposlit=slitx, yposlit=ylin, graphics = "stdgraph")
        omspestat(filin, xpos=slitx, yposlit=ylin, contflux=0.0, splotlo=linefitlog, xref=1040., yref=cons) #, basepix=5.0, cursor="")
	}
	
	print("Output linefit data written to ", linefitlog)
end

