procedure omextract(filnam, slitno)

string  filnam = "gtc14a_mos1abc" {prompt="File Name"}
string	slitno = "all"		{prompt="Slit numbers to slice [all, #]"}
int	nfind  =  1  	 	{prompt="Number of apertures to be found automatically"}
real	lamline=  INDEF 	{prompt="Dispersion line"}
string	referen= ""        	{prompt="List of aperture reference images"}
bool	interac=       no  	{prompt="Run task interactively?"}
bool	extras =       yes 	{prompt="Extract sky, sigma, etc.?"}
real	llimit =     INDEF 	{prompt="Lower aperture limit relative to center"}
real	ulimit =     INDEF 	{prompt="Upper aperture limit relative to center"}
real	ylevel =       0.1 	{prompt="Fraction of peak or intensity for automatic width"}
string	t_funct= "legendre"	{prompt="Trace fitting function"}
int	t_order=         5 	{prompt="Trace fitting function order"}
string	backgro= "none" 	{prompt="Background to subtract"}

begin
        string 	filin, sec[999], slitid, stype, s1, s2 #, apreferen, apt_funct, apbackgro
	string  reffile
	real	slitx, slity, slityx, slito #, apllimit, apulimit, apylevel
	real	lamcut, lamcen, dw, pixcen
        int     i1, nslits, ix1, ix2, islit, nslice, is, is1, is2, isl, line
	#int	apnfind, apline, apt_order
	bool	slice[999] #, apinterac, apextras

	filin = filnam; slitid = strlwr(slitno); lamcut = lamline; reffile = referen
	#apreferen = referen; apt_funct =t_funct; apbackgro = backgro
	#apllimit = llimit; apulimit = ulimit; apylevel = ylevel
	#apnfind = nfind; apline = line; apt_order = t_order
	#apinterac = interac; apextras = extras

	if (slitid != "all") {
	is = strstr("-", slitid)
	if (is != 0) {
	is1 = int(substr(slitid, 1, is - 1)); is2 = int(substr(slitid, is + 1, strlen(slitid)))
        for (isl = is1; isl <= is2; isl = isl + 1) { slice[isl] = yes }
	} else {
        files(slitid) | wc | scan(nslice)
        for (i = 1; i <= nslice; i = i + 1) {
	files(slitid) | fields (fields=1, lines=i) | scan(isl)
        slice[isl] = yes
        #print("Slit no ", i, " to slice = ", isl)
        }
	}
	}

        omslits (filin, verb-)
        nslits = omslits.nslitlets
        list = omslits.out

	if (lamcut == INDEF){line = INDEF} else {
        hselect (filin, "CRPIX2 CRVAL2 CDELT2", expr+) | scan(pixcen, lamcen, dw)
        line = int((lamcut - lamcen)/dw + pixcen)
	}
	print("Examining a cut at lambda=",lamcut," Ang, line = ", line)
        delete ("omextract.log", ver-, >& "dev$null")

        i1 = 0
        for (i = 1; i <= nslits; i = i + 1) {
        i1 = fscan(list, islit, ix1, ix2, slitx, slity, slityx, stype, slito)
	if (stype != "circular") {
        sec[i] = "["//str(ix1)//":"//str(ix2)//",*]"
        if (slitid == "all") {slice[i] = yes}
	if (slice[i] && reffile != filin//"_"//str(i)//".ms"){
	#printf ("%d ",i)
        imdelete (filin//"_"//str(i), ver-, >& "dev$null")
        imdelete (filin//"_"//str(i)//".ms", ver-, >& "dev$null")
	imcopy (filin//sec[i], filin//"_"//str(i), ver-)
	#apall (filin//"_"//str(i), int+, fittrac+, nfind=1, backgro="none", extras-, ylevel=0.2)
	print("Extracting slitlet #",i, " and saving in ", filin//"_"//str(i)//".ms")
	apall (filin//"_"//str(i), nfind=nfind, line=line, referen=reffile, interac=interac, 
	extras=extras, llimit=llimit, ulimit=ulimit, ylevel=ylevel, t_funct=t_funct, 
	t_order=t_order, backgro=backgro, >> "omextract.log")
	#imexpr("b>10.0*a ? 0.0 : a", filin//"_"//str(i)//".ms1", filin//"_"//str(i)//".ms", 
        imdelete (filin//"_"//str(i), ver-, >& "dev$null")
	}   #if (slice[i])
	}   #!= "circular" 
	}   #i = 1; i <= nslits
	#printf("\n")

end
