procedure omfitfunc

begin
	string	cskip, cline, fnam, ans
	real	c[99], nfun, ymin, ymax, zz[99]
	real	yfit, aa, bb, s, cc[9], c2fit, xcen, ycen, slity, slityx, slitx
	int	j, i, nn, k, nlin, nskip, ncoef, is, is1
	bool	skip
	real	yemp, yx, ce[4], ydif, slitdy, slitdyx

	#fnam = "gtc14a_mos1_arc1"
	fnam = "gtc14a_p1arc_m_HgArNe"
        #xcen=1040.0*2.0/xbin; ycen=995.0*2.0/ybin
        xcen=1040.0; ycen=995.0

	skip = no  
	# yes
	if (skip) goto part2

	ymin = 1; ymax = 2051.; nfun = 3.0
	if (nfun == 3.0) {nn = 3}
	c[1]=298.3967971976078; c[2]=467.3429471143019 
	c[3]=1248.193334354386; c[4]=2092.659956381334

	print ("Slitno to start plotting")
	scan (is1)
	#is=2; yx=1034.1590582759   #948.66728904502
	#for (is=1; is <= 36; is = is + 1) {
	for (is=is1; is <= is1; is = is + 1) {
	fields ("database/id"//fnam//"_"//str(is), fields="2", lines="7") | scan (nlin)
	nskip = 7+nlin+9
	fields ("database/id"//fnam//"_"//str(is), fields="2", lines=nskip) | scan (ncoef)
	cskip = str(nskip+5)//"-"//str(nskip+ncoef)
	ncoef = ncoef - 4
	for (k=1; k <= ncoef; k = k + 1) {
	#fields ("database/idgtc14a_mos1_arc1_29", fields="1", lines=cskip) 
	fields ("database/id"//fnam//"_"//str(is), fields="1", lines=nskip+4+k) | scan (cc[k])
	}
	print (is, nlin, nskip, ncoef, cc[1], cc[2], cc[3], cc[4])
	fields ("osiris_mos_reduction.log", fields="4-6", lines=is) | scan (slity, slityx, slitx)
	slitdy = slity - ycen; slitdyx = slityx - ycen
	print (is, slity, slityx, slitx, slitdy, slitdyx, cc[1], cc[2], cc[3], cc[4], >> "osiris_slits_wcal_coef.dat")
	##print (cc[1], cc[2], cc[3], cc[4], >> "osiris_wcal_coef.dat")
	#}

	#goto partend

        delete ("fitfunc.dat", ver-, >& "dev$null")
        delete ("obsdata.dat", ver-, >& "dev$null")
	delete ("database/id"//fnam//"_emp_"//str(is), ver-, >& "dev$null")

	grism = "R1000B"
	#osiris_wcal_coef (yx) 
	omwcal_coef (slity, order=1, grating=grism) | scan (ce[4], ce[3], ce[2], ce[1])
	print (ce[1], ce[2], ce[3], ce[4])
	copy ("identify_template", "database/id"//fnam//"_emp_"//str(is), verb-)
	print (ce[1], >> "database/id"//fnam//"_emp_"//str(is))
	print (ce[2], >> "database/id"//fnam//"_emp_"//str(is))
	print (ce[3], >> "database/id"//fnam//"_emp_"//str(is))
	print (ce[4], >> "database/id"//fnam//"_emp_"//str(is))

	for (k = int(ymin); k <= int(ymax) + 1; k = k + 1) {
	y = real(k)

	s = (y - ymin)/(ymax - ymin); j = int(s)
	if (j == 1) {j = 0}

	aa = real(j)+1.0 - s; bb = s - real(j)
	zz[1] = aa**3
        zz[2] = 1.0 + 3.0*aa*(1.0 + aa*bb)
        zz[3] = 1.0 + 3.0*bb*(1.0 + aa*bb)
        zz[4] = bb**3

	yfit = 0.0;  yemp = 0.0
	for (i = 1; i <= nn+1; i = i + 1) {
		yemp = yemp + ce[i+j]*zz[i] 
		yfit = yfit + cc[i+j]*zz[i] 
		ydif = yfit - yemp
	#print (k, y, j, i)
	}
	#print (y, yfit, >> "fitfunc.dat")
	print (y, yfit, yemp, ydif, >> "fitfunc.dat")
	}
	cline=str(8)//"-"//str(7+nlin)
	#fields ("database/id"//fnam//"_"//str(is), fields="1-2", lines=cline) | graph (wx1=ymin-50., wx2=1.1*ymax, wy1 = 3000., wy2=8000., pointmode+,szmarke=0.02, marker = "circle")
	fields ("database/id"//fnam//"_"//str(is), fields="1-2", lines=cline, >> "obsdata.dat") 
        graph ("obsdata.dat", wx1=ymin-50., wx2=1.1*ymax, wy1 = 3000., wy2=8000., pointmode+,szmarke=0.02, marker = "circle")
	#fields ("fitfunc.dat", fields="1,3") | graph (append+, wx1=ymin-50., wx2=1.1*ymax, wy1 = 3000., wy2=8000.)
	graph ("fitfunc.dat", append+)

	flpr
	print ("Hit return for next slitlet (#)",is)
	scan (ans)
	}

	goto partend

#part5:
#        delete ("osiris_wcal_coef1_fit.dat", ver-, >& "dev$null")
#	fields ("osiris_wcal.dat", fields="3,8") | graph (pointmode+,szmarke=0.02, marker = "circle")
#	for (i = 800; i <= 1200; i = i + 1) {
#	  #c2fit = 799.0 - 0.330*real(i)
#	  c2fit = 510.0 - 0.350*real(i-995)
#	  print (i, c2fit, >> "osiris_wcal_coef1_fit.dat")
#	}
#	fields ("osiris_wcal_coef1_fit.dat", fields="1-2") | graph (append+)
#
#part4:
#        delete ("osiris_wcal_coef2_fit.dat", ver-, >& "dev$null")
#        fields ("osiris_wcal.dat", fields="3,9") | graph (pointmode+,szmarke=0.02, marker = "circle")
#        for (i = 800; i <= 1200; i = i + 1) {
#          c2fit = 1300.0 - 0.40*real(i-995)
#          print (i, c2fit, >> "osiris_wcal_coef2_fit.dat")
#        }
#        fields ("osiris_wcal_coef2_fit.dat", fields="1-2") | graph (append+)
#
part2:
        #print(i, stype, " ", filin, sec[i], " ", slity, " ", slityx, " ", slitx0, " ", ix1," ", ix2, >> "osiris_mos_reduction.log")

        delete ("osiris_wcal_coef3_fit.dat", ver-, >& "dev$null")
        fields ("osiris_wcal.dat", fields="2,10") | graph (pointmode+,szmarke=0.02, marker = "circle")
        for (i = 800; i <= 1300; i = i + 1) {
          c2fit = 2163.0 - 0.42*real(i-995)
          #c2fit = 2162.0 - 0.37*real(i-995)
          print (i, c2fit, >> "osiris_wcal_coef3_fit.dat")
        } 
	fields ("osiris_wcal_coef3_fit.dat", fields="1-2") | graph (append+)

partend:
	print ("DONE")

end

