procedure	omlinefit(filnam)

string  filnam  = ""      	{prompt="File Name"}
real	xposlit = 22.0		{prompt="X position of the slitlet"}
real	yposlit = 1011.0	{prompt="Y position of the slitlet"}
real	contflux= 1.0   	{prompt="Continuum flux (0 ==> cont level is zero)"}
string  graphics="stdgraph"     {prompt="Output graphics device"}
string  logfile = ""      {prompt="File Name"}

begin
	string filin, statsecl, statsecr, splotfilcur, splotfillog, cdisp
	string graphtyp
	real	slityx, slitx, disp, basewid, yl1, yl2, yr1, yr2 
	real	lint, rint, yl, yr, cflux #, xxx, yyy

        filin = filnam; slityx=yposlit; slitx=xposlit; graphtyp=graphics 
	disp = 1.0; cdisp = "1.0"; cflux = contflux
	hselect (filin, "CDELT2", expr+) | scan(cdisp)
	if (cdisp != " " && real(cdisp) > 0.01) {disp = real(cdisp)}
	#basewid = 5.0*disp #basewid = 15.0*disp
	basewid = 10.0*disp
	yl = slityx - 2.0*basewid; yr = slityx + 2.0*basewid
	yl1 = yl - 0.5*basewid; yl2 = yl + 0.5*basewid
	yr1 = yr - 0.5*basewid; yr2 = yr + 0.5*basewid

	splotfilcur = "splot_auto_cont.cursor"
	splotfillog = "splot_auto_cont.log"
        delete (splotfilcur, ver-, >& "dev$null")
        delete (splotfillog, ver-, >& "dev$null")
	print (yl1, " 0.0  1 m", >> splotfilcur)
	print (yl2, " 0.0  1 m", >> splotfilcur)
	print (yr1, " 0.0  1 m", >> splotfilcur)
	print (yr2, " 0.0  1 m", >> splotfilcur)
	print (yr2, " 0.0  1 q", >> splotfilcur)
	if (graphtyp == "stdgraph"){
	splot (filin, line=slitx, band=1, xmin=yl1, xmax=yr2, save_fi=splotfillog, cursor=splotfilcur, graphic=graphtyp) 
	} else {
	splot (filin, line=slitx, band=1, xmin=yl1, xmax=yr2, save_fi=splotfillog, cursor=splotfilcur, graphic=graphtyp, >& "dev$null") 
	}
	fields (splotfillog, fields="2", lines=3) | scan (lint)
	fields (splotfillog, fields="2", lines=4) | scan (rint)
	#print(disp, " ",lint, " ", rint)

	if (cflux == 0.0) {lint = 0.0; rint = 0.0}
	splotfilcur = "splot_auto_gaussfit.cursor"
	splotfillog = "splot_auto_gaussfit.log"
        delete (splotfilcur, ver-, >& "dev$null")
        delete (splotfillog, ver-, >& "dev$null")

	print (yl, " ", lint, " 1 k", >> splotfilcur)
	print (yr, " ", rint, " 1 k", >> splotfilcur)
	print (yr, " ", rint, " 1 q", >> splotfilcur)

	if (graphtyp == "stdgraph"){
	splot (filin, line=slitx, band=1, xmin=yl1, xmax=yr2, save_fi=splotfillog, cursor=splotfilcur, graphic="stdgraph")
	} else {
	splot (filin, line=slitx, band=1, xmin=yl1, xmax=yr2, save_fi=splotfillog, cursor=splotfilcur, graphic=graphtyp, >& "dev$null")
	}

	omlinefit.logfile = splotfillog

end
