procedure omskysort(filein, fileout)

string	filein = "gtc14aob4_object_sum_wl_tlt[136:184,*]"	{prompt="Input filename"}
string	fileout= "gtc14aob4_object_sum_wl_tlt_1"		{prompt="Output Sky subtracted filename"}
real	percent= 20.0						{prompt="Percentile value for sky [1-50]"}

begin
	string	filin, filout, skycol, filetmp1, filetmp2
	real	frac
	int	dsky

	filin = filein; filout = fileout; frac = percent/100.0

        filetmp1 = "temp_file_tmp1";  imdelete (filetmp1, ver-, >& "dev$null")
        filetmp2 = "temp_file_tmp2";  imdelete (filetmp2, ver-, >& "dev$null")
	imexpr ("a*0", filetmp2, filin, verb-)

	hselect (filin, "NAXIS1", expr+) | scan(dsky)
        imexpr("sort(a)", filetmp1, filin, verb-)
        skycol = "["//str(int(frac*dsky))//",*]"
	#print(dsky, " ", skycol)

        for (i = 1; i <= dsky; i = i + 1) {
        imcopy (filetmp1//skycol, filetmp2//"["//str(i)//",*]", ver-)
	}
        imexpr("a-b", fileout, filin, filetmp2, verb-)

end
