procedure omflat(infile)
#procedure omflat(infile, slitno)

#slitno = none obtains the median without slice and then copies back each section
#slitno =  all, first slices, obtains median and copies back
#slitno = # same as all, except that it does it only for the requested slitlet.

string  infile = "gtc14aob4_object_sum_wl_tlt"      {prompt="Input 2D file template"}
#string  slitno    = "all"          {prompt="Slit numbers to flatten [all, #, none]"}
string  outfile = "DEFAULT"    	   {prompt="Output Master flat"}
int     xwin    = "3"              {prompt="X window size of median filter"}
int     ywin    = "3"              {prompt="Y window size of median filter"}
string	medbound= "nearest"	   {prompt="Boundary (constant,nearest,reflect,wrap) for median"}
bool	illcorr = no		   {prompt="Do illumination correction along the slit?"}
bool	illinte = no		   {prompt="Enter illumin interactively?"}
string  illfunc = "spline3"	   {prompt="Fitting function in Illumination"}
int	illorde = 11	   	   {prompt="Fitting function order in Illumination"}
int	illnbin = 100   	   {prompt="Number of fitting bins in Illumination"}
bool    del     = yes            {prompt="Delete all intermediate files?"}

begin
	#string  filin, filen, outnam, filinp, function, sec[999], slitid, stype, s1, s2
	string  filin, filen, outnam, filinp, function, sec[999], stype, s1, s2
	string	boundary, statsec[999]
        real    slitx, slity, slityx, slito, flatnor, flat[999]
	int     xw, yw, i1, i2, order, nbin, nmode
        int     nslits, ix1, ix2, islit, nslice, is, is1, is2, isl
        bool    slice[999], delete, cor_ill, inter

        filinp = infile; xw = xwin; yw = ywin; outnam = outfile; delete = del
	nbin = illnbin; order = illorde; function = illfunc
	cor_ill = illcorr; inter = illinte; boundary = medbound

	#slitid = strlwr(slitno)
        #if (slitid != "all" && slitid != "none") {
        #is = strstr("-", slitid)
        #if (is != 0) {
        #is1 = int(substr(slitid, 1, is - 1)); is2 = int(substr(slitid, is + 1, strlen(slitid)))
        #for (isl = is1; isl <= is2; isl = isl + 1) { slice[isl] = yes }
        #} else {
        #files(slitid) | wc | scan(nslice)
        #for (i = 1; i <= nslice; i = i + 1) {
        #files(slitid) | fields (fields=1, lines=i) | scan(isl)
        #slice[isl] = yes
        #}
        #}
        #}

	i2 = strstr(".",filinp)
	if (i2 > 0) {i2 = i2 -1} else {i2 = strlen(filinp)}
        i1 = strstr("[",filinp)
	if (i1 == 0){filin = substr(filinp, 1, i2)}
        if (i1 > 0) {i2 = strstr("]",filinp); filin = substr(filinp, 1, i1-1)}

	if (strupr(outnam) == "DEFAULT") {outnam = filin//"_norm"}
    	imdelete (outnam, veri=no,  >& "dev$null")

        omslits (filin, verb-)
        nslits = omslits.nslitlets
        list = omslits.out

	#slitid == "all"
	nmode = 1  #omslits.obsmod
	#if (nmode > 1) {slitid == "none"}
        #if (slitid == "none") {
	if (nmode > 1) {
    	imdelete (filin//"_med", veri=no, >& "dev$null")
    	imdelete (filin//"_nor", veri=no,  >& "dev$null")
	#print ("Step 1: Running a median filter to the image")
	median (filin, filin//"_med", xw=xw, yw=yw, boundar=boundary, verb-)
	#print ("Step 2: Normalization --- original/median ")
	imarith (filin, "/", filin//"_med", filin//"_nor", verb=no)
	#if (cor_ill && nmode == 2) {
	if (cor_ill) {
	#print ("Step 3: Illumination correction")
    	imdelete (filin//"_ill", veri=no,  >& "dev$null")
	illum (filin//"_med", filin//"_ill", functio=function, order=order, interac=inter, bins=" ", nbins=nbin)
	#print ("Step 4: Master Flat = FlatNorm*FlatIllum")
    	imdelete (filin//"_flt", veri=no,  >& "dev$null")
	imarith (filin//"_nor", "*", filin//"_ill", filin//"_flt", verb=no)
        imcopy (filin//"_flt", outnam, ver-)
	} else {imcopy (filin//"_nor", outnam, ver-)}
	if (delete) {
    	imdelete (filin//"_med", veri=no, >& "dev$null")
    	imdelete (filin//"_nor", veri=no,  >& "dev$null")
    	imdelete (filin//"_ill", veri=no,  >& "dev$null")
    	imdelete (filin//"_flt", veri=no,  >& "dev$null")
	}
	}

	if (nmode == 1) {
	imexpr ("a*0", outnam, filinp, verb-)
        i1 = 0
        for (i = 1; i <= nslits; i = i + 1) {
        i1 = fscan(list, islit, ix1, ix2, slitx, slity, slityx, stype, slito)
        if (stype != "circular") {
        sec[i] = "["//str(ix1)//":"//str(ix2)//",*]"
        #if (slitid == "all") {slice[i] = yes}
	#if (slitid == "none") {slice[i] = no; imcopy (filin//"_nor"//sec[i], outnam//sec[i], ver-)}
        #if (slice[i]){
        imdelete (filin//"_"//str(i), ver-, >& "dev$null")
        imcopy (filin//sec[i], filin//"_"//str(i), ver-)

	filen = filin//"_"//str(i)
    	imdelete (filen//"_med", veri=no, >& "dev$null")
    	imdelete (filen//"_nor", veri=no,  >& "dev$null")
    	#imdelete (filen//"_llu", veri=no,  >& "dev$null")
    	imdelete (filen//"_flt", veri=no,  >& "dev$null")

	#print ("Step 1: Running a median filter to the image")
	median (filen, filen//"_med", xw=xw, yw=yw, boundar=boundary, verb-)
	#print ("Step 2: Normalization --- original/median ")
	imarith (filen, "/", filen//"_med", filen//"_nor", verb=no)
	if (cor_ill) {
	#print ("Step 3: Illumination correction")
	statsec[i] = "["//str(ix1)//":"//str(ix2)//","//str(int(slityx-10.0))//":"//str(int(slityx+10.0))//"]"
        imstat (filin//statsec[i], fields="midpt", format-) | scan (flat[i])
        flatnor = flat[i]/flat[1]
	print(filin//statsec[i], flat[i], flatnor, slityx, >> "temp1.dat")
	#illum (filen//"_med", filen//"_ill", functio=function, order=order, interac=inter, bins=" ", nbins=nbin)
	#print ("Step 4: Master Flat = FlatNorm*FlatIllum")
	#imarith (filen//"_nor", "*", filen//"_ill", filen//"_flt", verb=no)
	imarith (filen//"_nor", "*", flatnor, filen//"_flt", verb=no)
        imcopy (filen//"_flt", outnam//sec[i], ver-)
	} else {imcopy (filen//"_nor", outnam//sec[i], ver-)}

	if (delete) {
    	imdelete (filen//"_med", veri=no, >& "dev$null")
    	imdelete (filen//"_nor", veri=no,  >& "dev$null")
    	imdelete (filen//"_ill", veri=no,  >& "dev$null")
    	imdelete (filen//"_flt", veri=no,  >& "dev$null")
	}
        imdelete (filin//"_"//str(i), ver-, >& "dev$null")

        #}   #if (slice[i])
        }   #!= "circular"
        }   #i = 1; i <= nslits
	}
	#print (" *** Done *** ")
	hedit (outnam, "OMFLAT", "yes", add+, ver-, show-)
	hedit (outnam, "ILLCOR", cor_ill, add+, ver-, show-)

end

