procedure omidentify(filarc, coordli)

string  filarc = "gtc14aob1_arcs"       {prompt="Comparison arc file [arcfile]"}
string  coordli= "DEFAULT"   		{prompt="Line id coordinate list"}
string  cursor = "gtcinputs$identify_spline3_2.cursor"   {prompt="Cursor file for indentify"}
string  lastlis= ""   		        {prompt="Line id coordinate list"}

begin
        string 	filein, filin, stype, sec[999], autosec, wcalfil, linelist, curfile, grism
	#string	filsol, cskip
	real	slitx, slity, slityx
	int	i1, nslits, islit, ix1, ix2, npix, ixc  #, nlin, nskip, ncoef
	struct  line

        filein = filarc; linelist=coordli; curfile = cursor     #"identify1.cursor"
	if (cursor != "") {delete ("identify.rms", ver-, >& "dev$null")}

	hselect (filein, "NAXIS2 GRISM", expr+) | scan(npix, grism)
	if (strupr(linelist) == "DEFAULT") {linelist = "gtcinputs$"//grism//"_HgAr_Ne_Xe.dat"} 
	print("Linelist is = ",linelist)

	#filsol= "gtcinputs$idarco"//grism//".txt"
        #fields (filsol, fields="2", lines="7") | scan (nlin)
        #nskip = 7+nlin+9
        #fields (filsol, fields="2", lines=nskip) | scan (ncoef)
        #cskip = str(7+nlin+1)//"-"//str(nskip+ncoef)

        omslits (filein, verb-)
        nslits = omslits.nslitlets

        i1 = 0
        for (i = 1; i <= nslits; i = i + 1) {
        #for (i = 1; i <= 4; i = i + 1) {
        fields (omslits.out, fields="1-7", lines=i) | scan (islit, ix1, ix2, slitx, slity, slityx, stype)
	sec[i] = "["//str(ix1)//":"//str(ix2)//",*]"
	#if (stype == "longslit") {ixc = int(slitx)} else {ixc = nint((ix2-ix1+1)/2.0)}
	ixc = nint((ix2-ix1+1)/2.0)
	filin = filein//"_"//str(i); imdelete (filin, ver-, >& "dev$null") 
	imcopy (filein//sec[i], filin, ver-)
	#;            filin = filein

	autosec = "["//str(ixc)//",*]"
	if (!access("database")) {mkdir "database"}
	wcalfil = "database/id"//filin
	delete (wcalfil, ver-, >& "dev$null")

	date | scan(line)
	print("# ", line, >> wcalfil)
	print ("begin   identify ", filin//autosec, >> wcalfil)
	print ("        id       ", filin         , >> wcalfil)
	print ("        task        identify", >> wcalfil)
	print ("        image    ", filin//autosec, >> wcalfil)

	print (i, slityx, ixc, sec[i])
	omwcal_lines (slityx, findcen+, filarc=filin, slitx=ixc, npix=npix, verb-) #| cat >> wcalfil
	type (omwcal_lines.out, map_cc-, device="terminal")
	type (omwcal_lines.out, map_cc-, device="terminal", >> wcalfil)
        #fields (filsol, fields="", lines=cskip, >> wcalfil)
	identify (filin//autosec, coordli=linelist, minsep=10., func="spline3", order=1, cursor=curfile, autowri+)
	#imdelete (filin, ver-, >& "dev$null")
	}

	#omidentify.coordli = linelist
	omidentify.lastlis = linelist
	omreduce.filarc = filarc
	print("##########################################")
	print("The solution files are stored in database")
	if (cursor != "") {
	delete (filein//"_identify.rms", ver-, >& "dev$null")
	copy ("identify.rms", filein//"_identify.rms", verb-)
	delete ("identify.rms_stat", ver-, >& "dev$null")
	fields ("identify.rms", fields=1-4) | grep RMS | fields (fields=3, > "identify.rms_stat")

	#print("Median rms of ", tstat.rows, " slitlets is ", tstat.median")
	print("The statistics of the rms of the solution is shown below")
	tstat ("identify.rms_stat")
	print("   ")
	print("Use omreidentify to check and improve individual solutions") 
	#print("To do that run identify ", filin, " section=mid col")
	}

end
