procedure	omreidentify(rmsfile)

string	rmsfile = "identify.rms"	{prompt="rms file from omidentify"}
real	rmsmin  = 0.5			{prompt="Min rms reomidentify"}
real	resmin  = 0.0001		{prompt="Min rms reomidentify"}

begin

	string	rmsfil, c1, c2, c5, arcfil[999], junk, stype[999], filin, filhead
	real	obsrms, rmslim, maxerr, minerr, residual, obrms[999]
	int	i, i1, i2, il, islit, irep, ires, slitno, sbeg[999], send[999]
	int	k, irep0, ibad[999], irep_rms, i3
        struct  line

	rmsfil = rmsfile    #identify.rms
	#rmslim = 0.5; maxerr = 3.0*rmslim; minerr = 0.0001
	rmslim = rmsmin; maxerr = 3.0*rmslim; minerr = resmin

        list = rmsfil
        i1 = 0
        il = 0
	islit = 0
	irep  = 0
	ires  = 0
	junk = ""
        while( fscan(list,line) != EOF ) {
	i1 = i1 + 1
        c1 = substr(line,1,3)
	if (c1 =="Fea") {
	islit = islit + 1
	sbeg[islit] = i1 + 2
	print (line) | scan (c2, c2, c2, c2, c5)
	i2 = strlen(c5)
	arcfil[islit] = substr(c5, 1, i2-1)
	i3 = strldx("_", arcfil[islit])
	#print(i2, i3)
	filin = substr(c5, 1, i3-1); filhead = substr(c5, 1, i3)//"head.dat"
	if (!access(filhead)){omslits (filin, verb-); filhead = omslits.out }
	fields (filhead, fields=7, line=substr(c5, i3+1, i2-1)) | scan(stype[islit])
	#fields (substr(c5, 1, i3)//"head.dat", fields=7, line=substr(c5, i3+1, i2-1)) | scan(stype[islit])
	}
	if (c1 =="RMS") {
	print (line) | scan (c2, c2, obrms[islit])
	if (stype[islit] != "circular" && obrms[islit] > rmslim) {irep = irep + 1} 
	send[islit] = i1 - 1
	#print (islit, sbeg[islit], send[islit], obrms[islit] )
	}
	}
	irep_rms = irep
	print("######### Summary of Identification errors ############")
	print("No of slits with rms > ", rmslim, " = ", irep_rms)
	irep = 0
	for (i = 1; i <= islit; i = i + 1) {
	  if (stype[i] != "circular") {
		ires = 0
		if (obrms[i] > rmslim) { irep = irep + 1; ibad[irep] = i } else {
		for (j = sbeg[i]; j <= send[i]; j = j + 1) {
		fields (rmsfil, fields=5, line=j) | scan(residual)
		#print(residual)
		#if (obrms[i] <= rmslim) {
		if (abs(residual) > maxerr || abs(residual) < minerr ) {
		fields (rmsfil, fields=1-9, line=j) | scan(line)
		ires = ires + 1
		if (ires == 1) { irep = irep + 1; ibad[irep] = i } #end ires=1
			#print(i, arcfil[i], " ",obrms[i], residual, line) 
							} #end res>maxerr
					} #end j
		}   #end rms > rmslim
	   } #end if not circular
	} #end i

	#print("######### Summary of Identification errors ############")
	#print("No of rectangular slits with rms > ", rmslim, " = ", irep_rms)
	print("Additional number of slits with at least 1 badly identified line = ", (irep - irep_rms))
	print("######### Summary of Identification errors ############")
	#print("No of slits to be re-identified = ", irep)

repete:
	print("Exit [0], Reidentify all [999], Slit# to identify from the list below : ")
	for (i = 1; i <= irep; i = i + 1) {
	k = ibad[i]
	if (i==1) {print("Slit#  arcfil    rms")}
	print(k, arcfil[k], " ",obrms[k]) 
	}
	print("Number to Analyze [0, 999, #] : ")
	scan(slitno)

	if (slitno == 0){goto quit}
        if (slitno >= 1 && slitno <= islit ) {
	#identify (arcfil[slitno], section="mid col", coordli=omidentify.coordli)
	identify (arcfil[slitno], section="mid col", coordli=omidentify.lastlis)
	goto repete
	}
	if (slitno > islit){
	for (i = 1; i <= irep; i = i + 1) {
	#print("write slitno to re-identify [0 to exit]")
	#scan(slitno)
	#identify (arcfil[slitno], section="mid col")
	k = ibad[i]
	identify (arcfil[k], section="mid col", coordli=omidentify.lastlis)
	}
	}

quit:
	print("DONE")

end
