procedure	goghost(imlist)

string  imlist     ="images.lis"   {prompt="List file containing input fits filenames"}
real    xcen       = 1051.5        {prompt="X center of the TF wrt the image -52 or 2068 "}
real    ycen       = 980.0         {prompt="Y center of the TF wrt the image 1966 "}
real	magdif     = -5.8          {prompt="Relative strength of the ghost [magdif=star-ghost]"}
bool	ghostim    = no		   {prompt="Create ghost image?"}
bool	verbose    = no		   {prompt="Print messages about the progress of the task?"}

begin
        string  input_list, infile, s1, tmp, comm1, rad_st, mdif
	real    xc, yc
        int     i1, i2
	bool	talk
        struct  line

        input_list = imlist; xc = xcen; yc = ycen; mdif = str(magdif); talk = verbose

        i1 = 0
        list = input_list    
        while( fscan(list, line) != EOF ) {
        tmp = substr (line, 1, 1)
        if (tmp != "#") {
          i1=i1+1
          i2 = fscanf(line, "%s", s1)
	infile = s1

        imdelete(infile//"_rot", ver-, >& "dev$null")
	rotate (infile, infile//"_rot", rot=180.0, xin=xc, yin=yc, xout=xc, yout=yc, boundary="constant", constant=0.0, verb=talk)
	rad_st = "sqrt((real(I)-"//str(xc)//")**2 + (real(J)-"//str(yc)//")**2)"
	comm1 = rad_st//"<600 ? a-b*(10**(0.4*("//mdif//" - (1.5/600.0)*("//rad_st//" - 600.0)))) : a-b*0.001585"
	#comm1 = rad_st//"<600 ? a-b*(10**(0.4*(-5.4 - (1.5/600.0)*(sqrt((real(I)-"//str(xc)//")**2 + (real(J)-"//str(yc)//")**2) - 400.0)))) : a-b*0.001585"
	#comm1 = "a-b*(10**(0.4*(-5.6 - (1.4/400.0)*(sqrt((real(I)-"//str(xc)//")**2 + (real(J)-"//str(yc)//")**2) - 400.0))))"

	#print(comm1)
        imdelete(infile//"g", ver-, >& "dev$null")
	imexpr(comm1, infile//"g", infile, infile//"_rot", verb=talk)
        imdelete(infile//"_rot", ver-, >& "dev$null")
	print("The ghost-free image name is = ", infile//"g")
	if (ghostim) {
	  imdelete(infile//"_ghost", ver-, >& "dev$null")
	  imexpr("a-b", infile//"_ghost", infile, infile//"g", verb=talk)
	print("The ghost image name is = ", infile//"_ghost")
	}
	print("-------------------------------------------------")
	} }

end
