procedure	omskyplot(intab)

string	intab	="splot_auto_gaussfit_parameters.log"	{prompt="skyline table"}
string	plot	="median"	{prompt="skyline table"}
int	column	=4		{prompt="column no"}
real	percent = 2.0 		{prompt="The percentage level of the horizontal bars in the plot"}

begin
	string	tabl, aver
	int	col
	real	tlow, thi, yyy, yyy_lo, yyy_hi, x_min, x_max, perc

	tabl= intab; aver=plot; col = column; perc = percent/100.0

        #fields ("splot_auto_gaussfit_parameters.log", fields=col) | tstat #(, >& "dev$null")
        fields (tabl, fields=col) | tstat #(, >& "dev$null")
	tlow = tstat.median - 5.0*tstat.stddev
	thi  = tstat.median + 5.0*tstat.stddev
        fields (tabl, fields=1) | tstat 
	x_min  = tstat.vmin*0.9 
	x_max  = tstat.vmax*1.1 
        #fields ("splot_auto_gaussfit_parameters.log", fields=col) | tstat (lowlim=tlow, highlim=thi) #(, >& "dev$null")
        fields (tabl, fields=col) | tstat (lowlim=tlow, highlim=thi) #(, >& "dev$null")
	tlow = tstat.median - 5.0*tstat.stddev
	thi  = tstat.median + 5.0*tstat.stddev
        #fields ("splot_auto_gaussfit_parameters.log", fields=col) | sgraph (wb=tlow, wt=thi, crvstyle="pseudohist")
        fields (tabl, fields="1,"//str(col)) | graph (wy1=tlow, wy2=thi, pointmode+, marker="bhist")
        if (aver == "median") {yyy = tstat.median}
        if (aver == "mean") {yyy = tstat.mean}
	#yyy_hi = yyy + tstat.stddev; yyy_lo = yyy - tstat.stddev
	yyy_hi = yyy*(1.00 + perc); yyy_lo = yyy*(1.00 - perc)
	printf("%g %g \n %g %g \n", 0, yyy, x_max, yyy) | graph (app+, pointmode-, ltype=2)
	printf("%g %g \n %g %g \n", 0, yyy_lo, x_max, yyy_lo) | graph (app+, pointmode-, ltype=3)
	printf("%g %g \n %g %g \n", 0, yyy_hi, x_max, yyy_hi) | graph (app+, pointmode-, ltype=3)
	#printf("%g %g \n %g %g \n", 0, yyy, x_max, yyy) | sgraph (app+, crvstyle="straight", pattern="dotted")
	#printf("%g %g \n %g %g \n", 0, tstat.median, 999, tstat.median) | sgraph (app+, crvstyle="straight", pattern="dotted")

end

