procedure omstd(filstd, star_nam)

#The task omstd runs omreduce, standard and sensfunc

string  filstd  = ""   		{prompt="Stadard star file"}
string  star_nam=""    		{prompt="Star name in calibration list"}
string  filflat = "" 		{prompt="Master Flat file"}
string  lamsky  = "DEFAULT" 	{prompt="Lambda of a sky line in Ang"}
bool    checksky  = no          {prompt="Improve lambda calibration by checking a skyline?"}
bool    interac = no       	{prompt="Run apall interactively?"}
real	line    = INDEF         {prompt="Line number to plot to search stars"}
int     nfind   = 1		{prompt="Number of stars to find"}
bool    extras  =       yes     {prompt="Extract sky, sigma, etc.?"}
real    llimit  = INDEF      	{prompt="Lower aperture limit relative to center"}
real    ulimit  = INDEF      	{prompt="Upper aperture limit relative to center"}
real    ylevel  =       0.1      {prompt="Fraction of peak or intensity for automatic width"}
string	b_sampl ="-50:-40,40:50" {prompt="Background sample regions"}
string  t_funct = "legendre"     {prompt="Trace fitting function"}
int     t_order =         5      {prompt="Trace fitting function order"}
string  backgro = "median"       {prompt="Background to subtract"}
string  stdflux = "gtc_flux.std" {prompt="Output flux file (used by SENSFUNC)"}
string  extinct = "gtcinputs$tn_ext_curve.dat"     {prompt="Extinction curve file"}
string  caldir  ="find"  	{prompt="Directory containing calibration data"}
bool    sensfunc=yes      	{prompt="Run sensfunc?"}
string  senscur = "gtc_sense_curve" {prompt="Sensitivity function imagename"}

begin
	string	filin, stdfile, sensfile, dircal, star, starname, ans
	string	filflat0, lamskyc, outfile
	real	slity, ce[4], lamsky0
	bool	inter

	starname = " "
	filin = filstd; stdfile = stdflux; sensfile = senscur
	hselect (filin, "OBJECT", expr+) | scan(starname)
	print("Standard star name in the image header is = ",starname)
	star = strlwr(star_nam); dircal = strlwr(caldir)
	if (dircal == "find") {omfindstd (star); dircal = omfindstd.caldir}
	if (dircal == "null") {print("Check the star name or caldir"); goto goexit}
	if (access(stdfile)) {
	print("Output file ",stdfile," exists: append[a] or delete[d]?")
	scan(ans)
	if (strlwr(ans) == "d") {delete (stdfile, ver-, >& "dev$null")}
	}
	filflat0 = filflat; lamskyc = lamsky
	outfile = filin//"_wl"
	if (strupr(filflat0) == "DEFAULT") { filflat0 = ""}
	#filflat0 = omreduce.filflat
	#while (!imaccess(filflat0)){
	#	print("Flatfile ", filflat0, " doesn't exist. Give a valid file or write noflat for no flatfielding ")
	#	scan(filflat0); if (filflat0 == "noflat") {filflat0 = ""; goto omreduce}    }        }
	if (imaccess(filflat0)){outfile = outfile//"_flt"}
omreduce:
	if (strupr(lamskyc) == "DEFAULT") {lamsky0 = omreduce.lamsky} else {lamsky0 = real(lamsky)}
	#print(star, " ", dircal)
	print(lamsky0, " ",filflat0)
	#goto goexit

	omreduce (filin, filarc="std", filflat=filflat0, senscur="", tilt_sl-, fiducia-, checksk=checksk, lamsky=lamsky0)
	
        imdelete (outfile//".ms", ver-, >& "dev$null")
        apall (outfile, output="", nfind=nfind, line=line, referen="", interac=interac, 
	extras=extras, llimit=llimit, ulimit=ulimit, ylevel=ylevel, b_sampl=b_sampl, t_funct=t_funct,
        t_order=t_order, backgro=backgro, >> "omstd.log")

	standard (outfile//".ms", stdfile, extinct=extinct, caldir=dircal, star_nam=star, interac+)

	if (sensfunc) {
        	imdelete (sensfile, ver-, >& "dev$null")
		sensfunc (stdfile, sensfile, ignorea+, extinct=extinct, inter+) 
	}

goexit:
        #imdelete (filin//"_wl", ver-, >& "dev$null")
	print("")

	end
