procedure	osiris_lam_calib(lamcal, grisma)

string lamcal  = "gtc14aob009_arc_sum_head_sort.dat"    {prompt="Lambda Calibration coefficient datafile"}
string grisma  = "R2000B"      				{prompt="Grism"}

begin
	string	grism, calfile, lamfil
	real	aa,bb,cc,ee,ff, dy
	real	xslit, yslit, r1, r2, r3, r4, r5
	int	id, i2

	lamfil = lamcal
	#calfile = "home$MOS_lambda_calib_ydm.dat"
	calfile = "gtcinputs$MOS_lambda_calib.dat"
        #fields (calfile, fields="1", lines="1-")
        #print ("Grism name from the above list : ")
        #scan(grism)
	#grism = "R1000B"
	grism = grisma

        match (grism, calfile) | fields (fields="5-9") | scan (aa,bb,cc,ee,ff)

        #dy = -ee*abs(250.-1040.) -ff*(250.-1040.)

#ID    xslit             yslit           4046    4358     5460   6402     7032
#45   1608.8115290202   936.72084682778   193.94  374.98  938.83  1369.42  1643.15

        list = lamfil    #"gtc14aob003_arcs_head_sort.dat"
	while( fscan(list, line) != EOF ) {
        if (substr(line, 1, 1) != "#") {
        i2 = fscanf(line, "%d  %g %g %g  %g  %g %g %g", id, xslit, yslit, r1, r2, r3, r4, r5)
	dy = - ee*abs(xslit-1040.) - ff*(xslit-1040.)
	#printf("%3d  %8g %8g %8g  %8g  %8g %8g %8g \n", id, xslit, yslit, r1, r2, r3, r4, r5)
	yslit = yslit - 995.0
	r1 = r1 + dy; r2 = r2 + dy; r3 = r3 + dy; r4 = r4 + dy; r5 = r5 + dy
	printf("%3d  %8g %8g %8g  %8g  %8g %8g %8g \n", id, xslit, yslit, r1, r2, r3, r4, r5)
	}
	}

end
